/*
 *  SynDetector
 *
 *  MSC in Telecommunications
 *  Denial of Service Study
 *	Queens University Belfast
 *
 *  Author   : Matthew Hutchinson
 *  Contact  : m.hutchinson@ijug.org
 *  Web      : http://hutchinson.ijug.org
 *
 *  Created  : 01-Aug-03
 *  Filename : ClientSocket.h
 *			   Header file for custom CSniffSocket in ClientSocket.cpp
 *
 *  Library     : TCPIP_LIBv4 by Komodia Inc.  <open source>
 *	Download    : http://www.komodia.com/tcpip_lib4.zip
 *  API Support : http://www.komodia.com/help/default.htm 
 *  Copyright   : Copyright (c) 2000-2003 Barak Weichselbaum <barak@komodia.com>
 *                All rights reserved.
 *
 *  NOTICE      : This is a Proof Of Concept program for educational purposes only.
 *
 */


#if !defined(AFX_CLIENTSOCKET_H__4BC89B30_1C8E_4022_B1A9_806ED855D346__INCLUDED_)
#define AFX_CLIENTSOCKET_H__4BC89B30_1C8E_4022_B1A9_806ED855D346__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "SniffSocket.h"

class CClientSocket : public CSniffSocket  
{
public:
	// reset flood count function
	void ResetFloodCount();
	// bind to a specific address
	virtual BOOL Bind(const std::string& rSourceAddress, unsigned short usPort=0);
	// Ctor and Dtor
	CClientSocket(CListBox* pList, CEdit* fCount);
	virtual ~CClientSocket();
protected:
	virtual BOOL OnSocketReceive(int iErrorCode);
private:
	// analyze TCP headers
	int AnalyzeTCP(char* cTCPBuffer);	
	// the list box and flood counter
	CListBox* m_pList;
	CEdit* m_fCount;
	// the address
	std::string m_sAddress;
};

#endif // !defined(AFX_CLIENTSOCKET_H__4BC89B30_1C8E_4022_B1A9_806ED855D346__INCLUDED_)
